#!/usr/bin/env /proj/sot/ska/bin/perl

use warnings;
use strict;

use Regexp::Common;
use English;

my $pod = join('',<>);
my %head = (1 => '=',
	    2 => '-',
	    3 => '~',
	    4 => '^',
	   );


# Convert the formatting statements like F<<stuff>>
while ($pod =~ /([A-Z]) < ($RE{balanced}{-parens=>'<>'}) >/x ) {
    my $match = $MATCH;
    my $func = $1;
    my $arg = $2;
    die "What?  $func $arg\n" unless $arg =~ /^ < (.*) > $/xs;
    $arg = $1;
    my $newarg = get_new_format($func, $arg);
    print STDERR "Matched $match => $newarg\n";
    $pod =~ s/\Q$match\E/$newarg/g;
}

# Convert the formatting statements like F<stuff>
while ($pod =~ /([A-Z]) ($RE{balanced}{-parens=>'<>'})/x ) {
    my $match = $MATCH;
    my $func = $1;
    my $arg = $2;
    die "What?  $func $arg\n" unless $arg =~ /^ < (.*) > $/xs;
    $arg = $1;
    my $newarg = get_new_format($func, $arg);
    print STDERR "Matched: $match => $newarg\n";
    $pod =~ s/\Q$match\E/$newarg/g;
}

while ($pod =~ /^=head(\d) (.+)$/m) {
    my $match = $MATCH;
    my $level = $1;
    my $label = $2;
    $label =~ s/^\s+|\s+$//g;
    (my $under = $label) =~ s/./$head{$level}/g;
    print STDERR "Subst $match => $label\n$under\n";
    $pod =~ s/\Q$match\E/$label\n$under/g;
}

$pod =~ s/:\s*$/::\n/mg;

while ($pod =~ /^=item ([^*].*)$/m) {
    my $match = $MATCH;
    my $label = $1;
    $label =~ s/^\s+|\s+$//g;
    (my $under = $label) =~ s/./$head{4}/g;
    print STDERR "Subst $match => $label\n$under\n";
    $pod =~ s/\Q$match\E/$label\n$under/g;
}

$pod =~ s/=(over.*|back|item )//mg;

print $pod;

#while ($pod =~ /([A-Z]) ($RE{balanced}{-parens=>'<>'}) /xg ) {
#     print "Found $1$2\n";
#}


sub get_new_format {
    my ($func, $arg) = @_;
    $arg =~ s/^\s+|\s+$//g;
    my $newarg;
    if ($func =~ /[FC]/) {
	$newarg = qq{``$arg``};
    } elsif ($func eq 'I') {
	$newarg = qq{*$arg*};
    } elsif ($func eq 'B') {
	$newarg = qq{**$arg**};
    } elsif ($func eq 'C') {
	$newarg = qq{`$arg`_};
    } elsif ($func eq 'Z') {
	$newarg = '';
    } elsif ($func eq 'E') {
	$newarg = '<' if $arg eq 'lt';
	$newarg = '>' if $arg eq 'gt';
    } else {
	$newarg = $arg;
    }
    return $newarg;
}
